// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ngCordova', 'starter.controllers', 'pascalprecht.translate'])

.run(function($ionicPlatform, $state) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleLightContent();
    }
      // Hide the splash screen as soon as the device is ready
      if(window.navigator && window.navigator.splashscreen) {
          window.navigator.splashscreen.hide();
      }

      // BACK BUTTON
      $ionicPlatform.registerBackButtonAction(function (event) {
          if($state.current.name=="tab.whd-de"){
              navigator.app.exitApp();
          } else {
              navigator.app.backHistory();
          }

      }, 100);

      // ANALYTICS
      if (typeof analytics !== 'undefined'){
          analytics.startTrackerWithId('UA-61771216-1');
          analytics.trackView('App Start');
      }
  });
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $translateProvider) {

  // Sprache
  for(lang in translations){
      $translateProvider.translations(lang, translations[lang]);
  }

  $translateProvider.preferredLanguage("1");


  $ionicConfigProvider.tabs.position('bottom');


  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
    .state('tab', {
    url: "/tab",
    abstract: true,
    templateUrl: "templates/tabs.html"
  })

  // Each tab has its own nav history stack:

  .state('tab.whd-de', {
    url: '/whd-de',
    views: {
      'tab-whd': {
        templateUrl: 'templates/tab-whd-de.html',
        controller: 'WHDCtrl'
      }
    }
  })

  /*.state('tab.whd-uk', {
      url: '/whd-uk',
      views: {
          'tab-whd': {
              templateUrl: 'templates/tab-whd-uk.html',
              controller: 'WHDCtrl'
          }
      }
  })

  .state('tab.whd-fr', {
      url: '/whd-fr',
      views: {
          'tab-whd': {
              templateUrl: 'templates/tab-whd-fr.html',
              controller: 'WHDCtrl'
          }
      }
  })*/

  .state('tab.feedback', {
      cache: false,
      url: "/feedback",
      views: {
          'tab-impressum' :{
              templateUrl: "templates/tab-feedback.html",
              controller: 'FeedbackCtrl'
          }
      }
  })

  .state('tab.einstellungen', {
      cache: false,
      url: '/einstellungen',
      views: {
          'tab-einstellungen': {
              templateUrl: 'templates/tab-einstellungen.html',
              controller: 'EinstellungenCtrl'
          }
      }
  })

  .state('tab.impressum', {
      cache: false,
      url: '/impressum',
      views: {
          'tab-impressum': {
              templateUrl: 'templates/tab-impressum.html',
              controller: 'ImpressumCtrl'
          }
      }
  });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/tab/whd-de');

});
