angular.module('starter.controllers', [])

    .factory('$localstorage', ['$window', function($window) {
        var def = {
            version       : 1.11,
            updateRead    : 1,
            localversion  : 1,
            language      : 1,
            showStart     : true,
            showHelp      : true,

            device        : '{"obj":{},"platform":"","version":""}',

            Feedback      : '{"email":"","betreff":"Feature-Wunsch","text":""}',

            Locs          : '[{"id":1,"trans":"loc_1","checked":true},{"id":2,"trans":"loc_2","checked":false},{"id":3,"trans":"loc_3","checked":false},{"id":4,"trans":"loc_4","checked":false},{"id":6,"trans":"loc_6","checked":false}]',
            Nodes         : '[{"id":1,"trans":"node_1","checked":true},{"id":2,"trans":"node_2","checked":true},{"id":3,"trans":"node_3","checked":true},{"id":4,"trans":"node_4","checked":true},{"id":5,"trans":"node_5","checked":true},{"id":6,"trans":"node_6","checked":true},{"id":7,"trans":"node_7","checked":true},{"id":8,"trans":"node_8","checked":false},{"id":9,"trans":"node_9","checked":true},{"id":10,"trans":"node_10","checked":true},{"id":11,"trans":"node_11","checked":true},{"id":12,"trans":"node_12","checked":false},{"id":13,"trans":"node_13","checked":true},{"id":14,"trans":"node_14","checked":true},{"id":15,"trans":"node_15","checked":true},{"id":16,"trans":"node_16","checked":false},{"id":17,"trans":"node_17","checked":true},{"id":18,"trans":"node_18","checked":true},{"id":19,"trans":"node_19","checked":true},{"id":20,"trans":"node_20","checked":true},{"id":21,"trans":"node_21","checked":true},{"id":22,"trans":"node_22","checked":true},{"id":23,"trans":"node_23","checked":true},{"id":24,"trans":"node_24","checked":true},{"id":25,"trans":"node_25","checked":true},{"id":26,"trans":"node_26","checked":false},{"id":27,"trans":"node_27","checked":true},{"id":37,"trans":"node_37","checked":true},{"id":28,"trans":"node_28","checked":true},{"id":29,"trans":"node_29","checked":true},{"id":30,"trans":"node_30","checked":true},{"id":31,"trans":"node_31","checked":true},{"id":32,"trans":"node_32","checked":true},{"id":33,"trans":"node_33","checked":true},{"id":34,"trans":"node_34","checked":true},{"id":35,"trans":"node_35","checked":true},{"id":36,"trans":"node_36","checked":true}]',
            Orders        : 3,
            Pages         : 0,
            Badge         : 70,
            View          : '{"thumbs":70,"titles":true,"prices":2}',

            NodeCounts    : 0,
            PageCount     : 0
        };

        return {
            set: function(key, value) {
                $window.localStorage[key] = value;
            },
            get: function(key) {
                return $window.localStorage[key] || def[key];
            },
            getDef: function(key) {
                return def[key];
            },
            setObject: function(key, value) {
                $window.localStorage[key] = JSON.stringify(value);
            },
            setObjectKey: function(key, Objkey, value) {
                var local = JSON.parse($window.localStorage[key] || def[key]);
                local[Objkey] = value;
                $window.localStorage[key] = JSON.stringify(local);
            },
            setObjectSubKey: function(key, Objkey, Objkey2, value) {
                var local = JSON.parse($window.localStorage[key] || def[key]);
                local[Objkey][Objkey2] = value;
                $window.localStorage[key] = JSON.stringify(local);
            },
            getObject: function(key) {
                return JSON.parse($window.localStorage[key] || def[key]);
            },
            getDefObject: function(key) {
                return JSON.parse(def[key]);
            },
            diff: function(key){
                var local = JSON.parse($window.localStorage[key] || def[key]);
                var comp  = JSON.parse(def[key]);
                if(local !== comp)
                    return true;
                else
                    return false;
            },
            diffKey: function(key, Objkey){
                var local = JSON.parse($window.localStorage[key] || def[key]);
                var comp  = JSON.parse(def[key]);
                if(local[Objkey] !== comp[Objkey])
                    return true;
                else
                    return false;
            },
            diffSubKey: function(key, Objkey, Objkey2){
                var local = JSON.parse($window.localStorage[key] || def[key]);
                var comp  = JSON.parse(def[key]);
                if(local[Objkey][Objkey2] !== comp[Objkey][Objkey2])
                    return true;
                else
                    return false;
            }
        }
    }])


    .factory('$mem_scopes', function ($rootScope) {
        var mem = {};

        return {
            store: function (key, value) {
                $rootScope.$emit('scope.stored', key);
                mem[key] = value;
            },
            get: function (key) {
                return mem[key];
            }
        };
    })

    .factory('$whd_api', function($http, $q){
        var BASE_URL = "http://www.nerdsheaven.de";
        var items = [];
        var fail_1 = 0;
        var token = 'GeezXeLeSCN3Y5bJYTaGNzrhYJgfwev3';

        return {
            getPosts: function( $loc, $page, $node, $order ){
                var deferred = $q.defer();

                var api_locs = '';
                var api_nodes = '';

                $loc.forEach( function(element, index, array) {
                    if(element.checked === true) api_locs = api_locs + element.id + ',';
                });

                $node.forEach( function(element, index, array) {
                    if(element.checked === true) api_nodes = api_nodes + element.id + ',';
                });

                // Die letzten Kommas entfernen
                api_locs = api_locs.substring(0, api_locs.length - 1);
                api_nodes = api_nodes.substring(0, api_nodes.length - 1);

                $http.jsonp(
                    BASE_URL + '/whd-api.php?callback=JSON_CALLBACK',
                    {
                        params: {loc: api_locs, page: $page, node: api_nodes, order: $order, token: token},
                        timeout: 5000
                    }
                ).success( function(response) {
                    if( response.status === 'ok' ) {
                        fail_1 = 0;
                        items = response.entries;
                        deferred.resolve(new Array( fail_1, items, response.rows, response.pages, response.counts));
                    }else{
                        fail_1++;
                        deferred.reject(new Array( fail_1, false ));
                    }
                }).error( function(response) {
                    fail_1++;
                    deferred.reject(new Array( fail_1, false ));
                });

                return deferred.promise;
            },
            sendFeedback: function( $email, $betreff, $message ){
                var deferred = $q.defer();

                $http.jsonp(
                    BASE_URL + '/api/get_nonce/?callback=JSON_CALLBACK',
                    {
                        params: {controller: 'nh', method: 'send_feedback'},
                        timeout: 5000
                    }
                ).success( function(response) {
                    if ( $message.length < 10 )
                        deferred.reject('error_1');
                    else if (response.status === 'ok') {
                        // FORM
                        $http.jsonp(
                            BASE_URL + '/nh/send_feedback/?callback=JSON_CALLBACK',
                            {
                                params: {
                                    nonce: response.nonce,
                                    email: $email,
                                    betreff: $betreff,
                                    text: $message,
                                    platform: ionic.Platform.platform(),
                                    version: ionic.Platform.version(),
                                    device: ionic.Platform.device()['name']
                                }
                            }
                        ).success( function(response2) {
                            if (response2.data.status === 'ok')
                                deferred.resolve('success');
                            else
                                deferred.reject('error_3');
                        }).error( function(response2) {
                            deferred.reject('error_3');
                        });
                    }else
                        deferred.reject('error_2');
                }).error( function(response) {
                    fail_1++;
                    deferred.reject('error_2');
                });

                return deferred.promise;
            }
        }
    })

    .controller('WHDCtrl', function($scope, $mem_scopes, $localstorage, $state, $http, $window, $ionicScrollDelegate, $translate, $whd_api, $timeout, $location, $ionicPopup, $cordovaSocialSharing) {

        if (typeof analytics !== 'undefined') analytics.trackView('WHD');

        // Sprache initialisieren
        $translate.use( $localstorage.getObject('language').toString() );


        // Abgleich 2er Objects (Update)
        $scope.mergeObjects = function( data_sys, data_usr ) {
            data_sys.forEach( function(element, index, array) {
                if( data_usr[index] !== 'undefined' ){
                    data_usr[index] = data_sys[index];
                }
            });
            return data_usr;
        }

        // Patch auf aktuelle Version (Datenabgleich)
        if( parseFloat($localstorage.getObject('version')) > parseFloat($localstorage.getObject('localversion')) ){

            // Abgleich Locs
            var locs_sys = $localstorage.getDefObject('Locs');
            var locs_usr = $localstorage.getObject('Locs');

            locs_usr = $scope.mergeObjects( locs_sys, locs_usr );

            // Abgleich Nodes
            var nodes_sys = $localstorage.getDefObject('Nodes');
            var nodes_usr = $localstorage.getObject('Nodes');

            nodes_usr = $scope.mergeObjects( nodes_sys, nodes_usr );

            // Speichern
            $localstorage.setObject('Locs', locs_usr);
            $localstorage.setObject('Nodes', nodes_usr);

            // Done
            $localstorage.setObject('localversion', $localstorage.getObject('version'));
        }

        //$localstorage.setObject('showStart', true);
        //$localstorage.setObject('showHelp', true);
        //$localstorage.setObject('language', 1);

        // 1. Aufruf? Dann Einstellungen
        if( $localstorage.getObject('showStart') !== false ){
            $state.go('tab.einstellungen');
        }

        // Alert : Hilfe ausgeben
        if( $localstorage.getObject('showStart') !== true && $localstorage.getObject('showHelp') !== false ) {
            $translate(['alert_help', 'alert_help_txt']).then(function (translations) {
                $scope.showHelp = function () {
                    var alertPopup = $ionicPopup.alert({
                        title: translations['alert_help'],
                        template: translations['alert_help_txt']
                    });
                    alertPopup.then(function (res) {
                        $localstorage.setObject('showHelp', false);
                    });
                };
                $scope.showHelp();
            });
        }

        $mem_scopes.store('WHDCtrl', $scope);

        $scope.init = function()
        {
            if (typeof analytics !== 'undefined') analytics.trackEvent('WHD');
            // Erstmalig Content laden
            $scope.loadMore(0, false);
        };

        $scope.items        = [];
        $scope.hint         = false;
        $scope.settings     = false;
        $scope.nodes        = $localstorage.getObject('Nodes');
        $scope.locs         = $localstorage.getObject('Locs');
        $scope.order        = $localstorage.getObject('Orders');
        $scope.page         = $localstorage.getObject('Pages');
        $scope.page_max     = 0;
        $scope.badges       = $localstorage.getObject('Badge');
        $scope.thumbs       = $localstorage.getObject('View')['thumbs'];
        $scope.titles       = $localstorage.getObject('View')['titles'];
        $scope.prices       = $localstorage.getObject('View')['prices'];
        $scope.version      = $localstorage.getObject('version');
        $scope.updateRead   = $localstorage.getObject('updateRead');
        $scope.NodeCounts   = $localstorage.getObject('NodeCounts');
        $scope.PageCount    = $localstorage.getObject('PageCount');

        // Update/Changelog verbergen
        $scope.closeUpdate = function() {
            $scope.updateRead = $localstorage.getObject('version');
            $localstorage.setObject('updateRead', $localstorage.getObject('version'));
        }

        // Auf- / Zuklappen
        $scope.fold = function(type) {

            if(type === 'hint') {
                $scope.hint = !$scope.hint;
            }else if(type === 'settings') {
                $scope.settings = !$scope.settings;
            }
        }

        // Social Share
        $scope.socialShare = function(link, title, avg, sum, per) {
            $translate(['social_message', 'social_subject', 'instead']).then(function (translations) {
                if (typeof analytics !== 'undefined') analytics.trackEvent('Funktionen', 'SocialShare', link);
                $cordovaSocialSharing
                    .share(translations['social_message'] + title + ' - ' + sum + ' ' + translations['instead'] + ' ' + avg + ' (-' + per + '%)\n\n', translations['social_subject'], null, link) // Share via native share sheet
                    .then(function(result) {
                      // Success!
                    }, function(err) {
                      // An error occured. Show a message to the user
                    });
            });
        };

        // Scroll to Top
        $scope.scrollTop = function() {
            $ionicScrollDelegate.scrollTop();
        };
        $scope.scrollTo = function(id) {
            $location.hash(id);
            $ionicScrollDelegate.anchorScroll();
        };
        // Get Scroll Position
        $scope.getScrollPosition = function() {
            $scope.moveData = $ionicScrollDelegate.getScrollPosition().top;

            if($scope.moveData>=250){
                var elems = document.getElementsByClassName('scroll_top');
                for(var i = 0; i < elems.length; i++) {
                    elems[i].style.display = 'block';
                }
            }else if($scope.moveData<250){
                var elems = document.getElementsByClassName('scroll_top');
                for(var i = 0; i < elems.length; i++) {
                    elems[i].style.display = 'none';
                }
            }

        };

        // Locations
        $scope.changeLoc = function() {
            if (typeof analytics !== 'undefined') analytics.trackEvent('Funktionen', 'changeLoc', JSON.stringify($scope.locs));
            $localstorage.setObject('Locs', $scope.locs);

            $scope.loadMore(0, false);
        };

        // Kategorie
        $scope.changeNode = function() {
            if (typeof analytics !== 'undefined') analytics.trackEvent('Funktionen', 'changeNode', JSON.stringify($scope.nodes));
            $localstorage.setObject('Nodes', $scope.nodes);

            $scope.loadMore(0, false);
        };

        // Kategorie (alle an-/abwählen)
        $scope.changeNodeSelection = function(value) {
            if (typeof analytics !== 'undefined') analytics.trackEvent('Funktionen', 'changeNodeSelection', JSON.stringify($scope.nodes));
            var nodes = $localstorage.getObject('Nodes');
            nodes.forEach( function(element, index, array) {
                element.checked = value;
            });
            $localstorage.setObject('Nodes', nodes);
            $scope.nodes = nodes;

            $scope.loadMore(0, false);
        }

        // Sortierung
        $scope.changeOrder = function() {
            if (typeof analytics !== 'undefined') analytics.trackEvent('Funktionen', 'changeOrder', parseInt(this.order));
            $localstorage.setObject('Orders', parseInt(this.order));
            $scope.order = parseInt(this.order);

            $scope.loadMore(0, false);
        }

        $scope.number_format = function(number, decimals, dec_point, thousands_sep) {

            number = (number + '')
                .replace(/[^0-9+\-Ee.]/g, '');
            var n = !isFinite(+number) ? 0 : +number,
                prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
                sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
                dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
                s = '',
                toFixedFix = function(n, prec) {
                    var k = Math.pow(10, prec);
                    return '' + (Math.round(n * k) / k)
                            .toFixed(prec);
                };
            // Fix for IE parseFloat(0.55).toFixed(0) = 0;
            s = (prec ? toFixedFix(n, prec) : '' + Math.round(n))
                .split('.');
            if (s[0].length > 3) {
                s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
            }
            if ((s[1] || '')
                    .length < prec) {
                s[1] = s[1] || '';
                s[1] += new Array(prec - s[1].length + 1)
                    .join('0');
            }
            return s.join(dec);
        }

        // WHD-Währungszeichen
        $scope.getNumberFormat = function(price, currency, mode){
            if( mode == 1 ) {
                switch (currency) {
                    case 1:
                        return $scope.number_format(price, 2, ',', '') + '€';
                        break;
                    case 2:
                        return '&pound;' + $scope.number_format(price, 2, '.', ',');
                        break;
                    case 3:
                        return $scope.number_format(price, 2, '.', ',') + '$';
                        break;
                }
            }else{
                switch (currency) {
                    case 2:
                        return '&pound;' + $scope.number_format(price, 2, '.', ',');
                        break;
                    case 5:
                        return $scope.number_format(price, 2, '.', ',') + '$';
                        break;
                    default:
                        return $scope.number_format(price, 2, ',', '') + '€';
                        break;
                }
            }
        }

        // WHD-Währung
        $scope.getTransPrice = function(lang, price) {
            // Preis
            switch ( lang ) {
                // UK
                case 2:
                    return $scope.getNumberFormat( price.gbp[0], price.gbp[1], 1 );
                    break;
                // US
                case 5:
                    return $scope.getNumberFormat( price.usd[0], price.usd[1], 1 );
                    break;
                // DE, FR, IT
                default:
                    return $scope.getNumberFormat( price.eur[0], price.eur[1], 1 );
                    break;

            }
        }
        $scope.getTransFloat = function(lang, price) {
            // Preis
            switch ( lang ) {
                // UK
                case 2:
                    return price.gbp[0];
                    break;
                // US
                case 5:
                    return price.usd[0];
                    break;
                // DE, FR, IT
                default:
                    return price.eur[0];
                    break;

            }
        }

        // WHD-Preis
        $scope.getPrice = function(lang, prices){
            if( prices.acceptable.eur[0] > 0 )

                return $scope.getTransPrice( lang, prices.acceptable );

            else if( prices.good.eur[0] > 0 )

                return $scope.getTransPrice( lang, prices.good );

            else if( prices.verygood.eur[0] > 0 )

                return $scope.getTransPrice( lang, prices.verygood );

            else if( prices.mint.eur[0] > 0 )

                return $scope.getTransPrice( lang, prices.mint );

            else

                return '';
        }

        // Ersparnis berechnen
        $scope.getSavings = function(comp, price){
            comp = parseFloat(comp);
            price = parseFloat(price);

            if( price > 0 && comp > 0 && (comp > price) ){
                // Prozent mit 2 Kommastellen
                var percent = (100-(100/(comp/price))).toFixed(2);
                // Ersparnis SUM, %
                return new Array ( (comp-price).toFixed(2), percent);
            }
            return new Array (0, 0);
        }

        // Amazon Redirect
        $scope.goto = function(url, node_id) {
            if (typeof analytics !== 'undefined') analytics.trackEvent('Affiliate', node_id, url );

            //navigator.app.loadUrl(url, { openExternal:true });
            //$window.open(url, '_blank', 'location=yes');

            $window.open(url, '_blank', 'location=yes');
        }

        // Zurück zur ersten Seite?
        $scope.resetWHD = function() {
            $scope.page = 0;
            $scope.page_max = 0;
            $scope.loadMore(0, false);
        }

        // Neu laden?
        $scope.reloadWHD = function() {
            $scope.page_max = 0;
            $scope.loadMore(true, false);
        }

        // Content laden
        $scope.loadMore = function(page, scrolltop) {

            document.getElementById('no_selection').style.display = '';
            document.getElementById('whd_buttons_first').style.display = '';
            document.getElementById('whd_buttons_last').style.display = '';
            // PageCount ausblenden
            var elems = document.getElementsByClassName('whd_pagecount');
            for (var i = 0; i < elems.length; i++) {
                elems[i].style.display = 'none';
            }

            // Wenigstens ein Loc und Node ausgewählt?
            var checked_loc = false;
            var checked_nodes = false;
            $scope.locs.forEach( function(element, index, array) {
                if(element.checked === true){
                    checked_loc = true;
                    return true;
                }
            });
            $scope.nodes.forEach( function(element, index, array) {
                if(element.checked === true){
                    checked_nodes = true;
                    return true;
                }
            });

            // Fehlermeldung weil Loc oder Nodes leer?
            if( checked_loc === false || checked_nodes === false ){
                // vorhandene Items löschen
                $scope.items = [];
                // Fehlermeldung
                document.getElementById('no_selection').style.display = 'block';
                // Navibuttons
                document.getElementById('whd_buttons_first').style.display = 'none';
                document.getElementById('whd_buttons_last').style.display = 'none';
            }else {

                // Ladeanimation anzeigen
                document.getElementById('spinner').style.display = 'block';

                // WHD Buttons ausblenden
                var elems = document.getElementsByClassName('whd_buttons');
                for (var i = 0; i < elems.length; i++) {
                    elems[i].style.display = 'none';
                }

                // vorhandene Items löschen
                $scope.items = [];

                var locs = $localstorage.getObject('Locs');
                var nodes = $localstorage.getObject('Nodes');
                var order = $localstorage.getObject('Orders');
                // Fail? Reload!
                page = page === true ? $scope.page : page;

                // ITEMS
                $whd_api.getPosts(locs, page, nodes, order).then(function (response) {

                    $translate(['pt_avg', 'pt_new', 'pt_mint', 'pt_verygood', 'pt_good', 'pt_acceptable']).then(function (translations) {

                        // Ladeanimation ausblenden
                        document.getElementById('spinner').style.display = 'none';

                        // Hochscrollen
                        if (page == 0 && scrolltop === true)
                            $scope.scrollTo('whd_first');
                        else if (scrolltop === true)
                            $scope.scrollTo('whd_buttons_first');

                        // WHD Buttons anzeigen
                        var elems = document.getElementsByClassName('whd_buttons');
                        for (var i = 0; i < elems.length; i++) {
                            elems[i].style.display = '';
                        }

                        // PageCount anzeigen
                        var elems = document.getElementsByClassName('whd_pagecount');
                        for (var i = 0; i < elems.length; i++) {
                            elems[i].style.display = '';
                        }

                        // Bei Erfolg PageCount erhöhen
                        $scope.page = page;
                        $scope.page_max = response[3];

                        // Reload ausblenden
                        document.getElementById('refresh_after_fail').style.display = 'none';

                        // Counts
                        $scope.NodeCounts   = response[4];
                        $scope.PageCount    = response[3];
                        $localstorage.setObject('NodeCounts', response[4]);
                        $localstorage.setObject('PageCount', response[3]);

                        // ITEMS
                        angular.forEach(response[1], function (obj) {

                            var prices = obj.org_prices;

                            // Titel kürzen
                            //if (obj.custom_fields.whd_meta.title.length > 75)
                            //    obj.custom_fields.whd_meta.title = obj.custom_fields.whd_meta.title.substr(0, 75) + '...';

                            // ERSPARNISSE
                            var sav_new = $scope.getSavings($scope.getTransFloat(parseInt($localstorage.getObject('language')), prices.avg), $scope.getTransFloat(parseInt($localstorage.getObject('language')), prices.new));
                            var sav_mint = $scope.getSavings($scope.getTransFloat(parseInt($localstorage.getObject('language')), prices.avg), $scope.getTransFloat(parseInt($localstorage.getObject('language')), prices.mint));
                            var sav_verygood = $scope.getSavings($scope.getTransFloat(parseInt($localstorage.getObject('language')), prices.avg), $scope.getTransFloat(parseInt($localstorage.getObject('language')), prices.verygood));
                            var sav_good = $scope.getSavings($scope.getTransFloat(parseInt($localstorage.getObject('language')), prices.avg), $scope.getTransFloat(parseInt($localstorage.getObject('language')), prices.good));
                            var sav_acceptable = $scope.getSavings($scope.getTransFloat(parseInt($localstorage.getObject('language')), prices.avg), $scope.getTransFloat(parseInt($localstorage.getObject('language')), prices.acceptable));

                            // Neupreis + niedrigster Gebrauchtpreis
                            if ($scope.prices === 2) {

                                var t_avg = prices.avg.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.avg) + '</span>' : '-';
                                var line_avg = '<tr class="avia-heading-row"><td>' + translations['pt_avg'] + '</td><td>' + t_avg + '</td><td><i class="icon ion-ios-pricetag"></i></td></tr>';

                                var t_new = prices.new.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.new) + '</span>' : '-';
                                var line_new = '<tr><td>' + translations['pt_new'] + '</td><td>' + t_new + '</td><td>' + (( sav_new[0] > 0 && sav_new[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_new[1] + '%</span>' : '-') + '</td></tr>';

                                var changed = 0;

                                if (prices.acceptable.eur[0] > 0 && changed === 0) {
                                    changed = 1;
                                    var t_acceptable = prices.acceptable.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.acceptable) + '</span>' : '-';
                                    var line_acceptable = '<tr><td>' + translations['pt_acceptable'] + '</td><td>' + t_acceptable + '</td><td>' + (( sav_acceptable[0] > 0 && sav_acceptable[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_acceptable[1] + '%</span>' : '-') + '</td></tr>';
                                } else
                                    var line_acceptable = '';

                                if (prices.good.eur[0] > 0 && changed === 0) {
                                    changed = 1;
                                    var t_good = prices.good.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.good) + '</span>' : '-';
                                    var line_good = '<tr><td>' + translations['pt_good'] + '</td><td>' + t_good + '</td><td>' + (( sav_good[0] > 0 && sav_good[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_good[1] + '%</span>' : '-') + '</td></tr>';
                                } else
                                    var line_good = '';

                                if (prices.verygood.eur[0] > 0 && changed === 0) {
                                    changed = 1;
                                    var t_verygood = prices.verygood.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.verygood) + '</span>' : '-';
                                    var line_verygood = '<tr><td>' + translations['pt_verygood'] + '</td><td>' + t_verygood + '</td><td>' + (( sav_verygood[0] > 0 && sav_verygood[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_verygood[1] + '%</span>' : '-') + '</td></tr>';
                                } else
                                    var line_verygood = '';

                                if (changed === 0) {
                                    changed = 1;
                                    var t_mint = prices.mint.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.mint) + '</span>' : '-';
                                    var line_mint = '<tr><td>' + translations['pt_mint'] + '</td><td>' + t_mint + '</td><td>' + (( sav_mint[0] > 0 && sav_mint[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_mint[1] + '%</span>' : '-') + '</td></tr>';
                                } else
                                    var line_mint = '';

                                // Neupreis
                            } else if ($scope.prices === 3) {

                                var t_avg = prices.avg.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.avg) + '</span>' : '-';
                                var line_avg = '<tr class="avia-heading-row"><td>' + translations['pt_avg'] + '</td><td>' + t_avg + '</td><td><i class="icon ion-ios-pricetag"></i></td></tr>';

                                var t_new = prices.new.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.new) + '</span>' : '-';
                                var line_new = '<tr><td>' + translations['pt_new'] + '</td><td>' + t_new + '</td><td>' + (( sav_new[0] > 0 && sav_new[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_new[1] + '%</span>' : '-') + '</td></tr>';

                                var line_mint = '';
                                var line_verygood = '';
                                var line_good = '';
                                var line_acceptable = '';

                                // Niedrigster Gebrauchpreis
                            } else if ($scope.prices === 4) {

                                var line_avg = '';
                                var line_new = '';

                                var changed = 0;

                                if (prices.acceptable.eur[0] > 0 && changed === 0) {
                                    changed = 1;
                                    var t_acceptable = prices.acceptable.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.acceptable) + '</span>' : '-';
                                    var line_acceptable = '<tr><td>' + translations['pt_acceptable'] + '</td><td>' + t_acceptable + '</td><td>' + (( sav_acceptable[0] > 0 && sav_acceptable[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_acceptable[1] + '%</span>' : '-') + '</td></tr>';
                                } else
                                    var line_acceptable = '';

                                if (prices.good.eur[0] > 0 && changed === 0) {
                                    changed = 1;
                                    var t_good = prices.good.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.good) + '</span>' : '-';
                                    var line_good = '<tr><td>' + translations['pt_good'] + '</td><td>' + t_good + '</td><td>' + (( sav_good[0] > 0 && sav_good[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_good[1] + '%</span>' : '-') + '</td></tr>';
                                } else
                                    var line_good = '';

                                if (prices.verygood.eur[0] > 0 && changed === 0) {
                                    changed = 1;
                                    var t_verygood = prices.verygood.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.verygood) + '</span>' : '-';
                                    var line_verygood = '<tr><td>' + translations['pt_verygood'] + '</td><td>' + t_verygood + '</td><td>' + (( sav_verygood[0] > 0 && sav_verygood[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_verygood[1] + '%</span>' : '-') + '</td></tr>';
                                } else
                                    var line_verygood = '';

                                if (prices.mint.eur[0] > 0 && changed === 0) {
                                    changed = 1;
                                    var t_mint = prices.mint.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.mint) + '</span>' : '-';
                                    var line_mint = '<tr><td>' + translations['pt_mint'] + '</td><td>' + t_mint + '</td><td>' + (( sav_mint[0] > 0 && sav_mint[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_mint[1] + '%</span>' : '-') + '</td></tr>';
                                } else
                                    var line_mint = '';

                                // VOLL
                            } else {

                                var t_avg = prices.avg.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.avg) + '</span>' : '-';
                                var line_avg = '<tr class="avia-heading-row"><td>' + translations['pt_avg'] + '</td><td>' + t_avg + '</td><td><i class="icon ion-ios-pricetag"></i></td></tr>';

                                var t_new = prices.new.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.new) + '</span>' : '-';
                                var line_new = '<tr><td>' + translations['pt_new'] + '</td><td>' + t_new + '</td><td>' + (( sav_new[0] > 0 && sav_new[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_new[1] + '%</span>' : '-') + '</td></tr>';

                                var t_mint = prices.mint.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.mint) + '</span>' : '-';
                                var line_mint = '<tr><td>' + translations['pt_mint'] + '</td><td>' + t_mint + '</td><td>' + (( sav_mint[0] > 0 && sav_mint[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_mint[1] + '%</span>' : '-') + '</td></tr>';

                                var t_verygood = prices.verygood.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.verygood) + '</span>' : '-';
                                var line_verygood = '<tr><td>' + translations['pt_verygood'] + '</td><td>' + t_verygood + '</td><td>' + (( sav_verygood[0] > 0 && sav_verygood[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_verygood[1] + '%</span>' : '-') + '</td></tr>';

                                var t_good = prices.good.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.good) + '</span>' : '-';
                                var line_good = '<tr><td>' + translations['pt_good'] + '</td><td>' + t_good + '</td><td>' + (( sav_good[0] > 0 && sav_good[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_good[1] + '%</span>' : '-') + '</td></tr>';

                                var t_acceptable = prices.acceptable.eur[0] > 0 ? '<span style="color:#80bc2a">' + $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.acceptable) + '</span>' : '-';
                                var line_acceptable = '<tr><td>' + translations['pt_acceptable'] + '</td><td>' + t_acceptable + '</td><td>' + (( sav_acceptable[0] > 0 && sav_acceptable[1] > 0 ) ? '<span style="color:#BC2A2A">- ' + sav_acceptable[1] + '%</span>' : '-') + '</td></tr>';

                            }

                            // SOCIAL SHARE - NIEDRIGSTER PREIS
                            var changed = 0;
                            obj.social_avg = $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.avg);
                            obj.social_sum = 0;
                            obj.social_per = 0;
                            if (prices.acceptable.eur[0] > 0 && changed === 0) {
                                changed = 1;
                                obj.social_sum = $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.acceptable);
                                obj.social_per = obj.acceptable_sav_per;
                            }
                            if (prices.good.eur[0] > 0 && changed === 0) {
                                changed = 1;
                                obj.social_sum = $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.good);
                                obj.social_per = obj.good_sav_per;
                            }
                            if (prices.verygood.eur[0] > 0 && changed === 0) {
                                changed = 1;
                                obj.social_sum = $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.verygood);
                                obj.social_per = obj.verygood_sav_per;
                            }
                            if (prices.mint.eur[0] > 0 && changed === 0) {
                                changed = 1;
                                obj.social_sum = $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.mint);
                                obj.social_per = obj.mint_sav_per;
                            }
                            if (prices.new.eur[0] > 0 && changed === 0) {
                                changed = 1;
                                obj.social_sum = $scope.getTransPrice(parseInt($localstorage.getObject('language')), prices.new);
                                obj.social_per = obj.new_sav_per;
                            }

                            // PRICETABLE
                            obj.ptable = '<table class="ptable"><tbody>' + line_avg + line_new + line_mint + line_verygood + line_good + line_acceptable + '</tbody></table>';

                            // BADGE
                            obj.sav_badge = $scope.number_format(obj.sav_per, 0, '', '');
                            if (obj.sav_per > 75)
                                obj.badge = 'badge-assertive';
                            else if (obj.sav_per > 50)
                                obj.badge = 'badge-royal';
                            else if (obj.sav_per > 25)
                                obj.badge = 'badge-nhgreen';
                            else
                                obj.badge = 'badge-nhblue';

                            // FLAGGE
                            if (obj.loc == 2)
                                obj.iso = 'gb';
                            else if (obj.loc == 3)
                                obj.iso = 'it';
                            else if (obj.loc == 4)
                                obj.iso = 'fr';
                            else if (obj.loc == 5)
                                obj.iso = 'us';
                            else if (obj.loc == 6)
                                obj.iso = 'es';
                            else
                                obj.iso = 'de';

                            this.push(obj);
                        }, $scope.items);

                    });

                },
                // FEHLER
                function (response) {
                    // Fail Count überschritten? => Reload anzeigen
                    if (response[0] >= 3) {
                        // Ladeanimation ausblenden
                        document.getElementById('spinner').style.display = 'none';
                        // Neu laden anzeigen
                        document.getElementById('refresh_after_fail').style.display = 'block';
                    } else
                        $timeout(function () {
                            $scope.loadMore(true, true)
                        }, 3000);
                });
            }
        }
        // Manuell nach Fail
        $scope.loadMoreManuell = function() {
            // Button ausblenden
            document.getElementById('refresh_after_fail_button').style.display = 'none';
            // Versuche neu zu laden
            $scope.loadMore(true, true);
            // Bei nochmaligen Fail Button wieder anzeigen
            setTimeout(function () {
                document.getElementById('refresh_after_fail_button').style.display = 'inline-block';
            }, 2000);
        }

    })

    .controller('FeedbackCtrl', function($scope, $mem_scopes, $localstorage, $timeout, $http, $state, $translate, $whd_api) {

        $mem_scopes.store('FeedbackCtrl', $scope);

        if (typeof analytics !== 'undefined') analytics.trackView('Feedback');

        $scope.email    = '';
        $scope.betreff  = 'Feature-Wunsch';
        $scope.message  = '';

        $scope.changeEmail = function() {
            $scope.email = this.email;
        }

        $scope.changeBetreff = function() {
            $scope.betreff = this.betreff;
        };

        $scope.changeMessage = function() {
            $scope.message = this.message;
        }

        $scope.doCancel = function() {
            $state.go('tab.impressum');
        }

        $scope.submitFeedback = function() {
            $whd_api.sendFeedback( $scope.email, $scope.betreff, $scope.message ).then(function( response ){
                $translate(['feedback_msg_1','feedback_msg_2','feedback_msg_3']).then(function (translations) {
                    if (typeof analytics !== 'undefined') analytics.trackEvent('Feedback', 'Error', 'Erfolg');
                    document.getElementById('feedback-success').innerHTML = translations['feedback_msg_3'];
                    document.getElementById('feedback-success').style.display = 'block';
                    $timeout(function () {
                        document.getElementById('feedback-success').style.display = 'none';
                        $state.go('tab.impressum');
                    }, 5000);
                });
            },
            // FEHLER
            function(response) {
                $translate(['feedback_msg_1','feedback_msg_2','feedback_msg_3']).then(function (translations) {
                    // Nachricht < 10 Zeichen
                    if (response === 'error_1') {
                        if (typeof analytics !== 'undefined') analytics.trackEvent('Feedback', 'Error', '1');
                        document.getElementById('feedback-error').innerHTML = translations['feedback_msg_1'];
                        // Senden #1
                    } else if (response === 'error_2') {
                        if (typeof analytics !== 'undefined') analytics.trackEvent('Feedback', 'Error', '2');
                        document.getElementById('feedback-error').innerHTML = translations['feedback_msg_2'];
                        // Senden #2
                    } else {
                        if (typeof analytics !== 'undefined') analytics.trackEvent('Feedback', 'Error', '3');
                        document.getElementById('feedback-error').innerHTML = translations['feedback_msg_3'];
                    }
                    document.getElementById('feedback-error').style.display = 'block';
                    setTimeout(function () {
                        document.getElementById('feedback-error').style.display = 'none';
                    }, 5000);
                });
            });
        }

    })

    .controller('EinstellungenCtrl', function($scope, $mem_scopes, $state, $localstorage, $translate, $ionicHistory, $ionicPopup) {

        $mem_scopes.store('EinstellungenCtrl', $scope);

        // Sprache initialisieren
        $translate.use( $localstorage.getObject('language').toString() );
        var language = parseInt($localstorage.getObject('language').toString());
        $scope.language = $localstorage.getObject('showStart') !== true ? $localstorage.getObject('language') : 0;
        $scope.badges   = $localstorage.getObject('Badge');
        $scope.thumbs   = $localstorage.getObject('View')['thumbs'];
        $scope.titles   = $localstorage.getObject('View')['titles'];
        $scope.prices   = $localstorage.getObject('View')['prices'];

        // Alert : Sprache wählen
        if( $localstorage.getObject('showStart') !== false ) {
            $scope.showAlert = function () {
                var alertPopup = $ionicPopup.alert({
                    title: "Sprache / Language / Lingua / Langue / Idioma",
                    template: "&bull; Bitte wähle deine <strong>Sprache</strong> aus<br>&bull; Please select your <strong>language</strong><br>&bull; Si prega di selezionare la vostra <strong>lingua</strong><br>&bull; S'il vous plaît sélectionnez votre <strong>langue</strong><br>&bull; Seleccione su <strong>idioma</strong>"
                });
                alertPopup.then(function (res) {
                    //console.log('Thank you for not eating my delicious ice cream cone');
                });
            };
            $scope.showAlert();
        }

        // Sprache wechseln
        $scope.changeLanguage = function(value) {
            // Start abgehakt
            $localstorage.setObject('showStart', false);

            $localstorage.setObject('language', value);
            $translate.use(value.toString());

            value = parseInt(value);

            switch(value){
                case 2:
                    $localstorage.setObject('Locs', [{"id":1,"trans":"loc_1","checked":false},{"id":2,"trans":"loc_2","checked":true},{"id":3,"trans":"loc_3","checked":false},{"id":4,"trans":"loc_4","checked":false},{"id":6,"trans":"loc_6","checked":false}]);
                    break;
                case 3:
                    $localstorage.setObject('Locs', [{"id":1,"trans":"loc_1","checked":false},{"id":2,"trans":"loc_2","checked":false},{"id":3,"trans":"loc_3","checked":true},{"id":4,"trans":"loc_4","checked":false},{"id":6,"trans":"loc_6","checked":false}]);
                    break;
                case 4:
                    $localstorage.setObject('Locs', [{"id":1,"trans":"loc_1","checked":false},{"id":2,"trans":"loc_2","checked":false},{"id":3,"trans":"loc_3","checked":false},{"id":4,"trans":"loc_4","checked":true},{"id":6,"trans":"loc_6","checked":false}]);
                    break;
                case 6:
                    $localstorage.setObject('Locs', [{"id":1,"trans":"loc_1","checked":false},{"id":2,"trans":"loc_2","checked":false},{"id":3,"trans":"loc_3","checked":false},{"id":4,"trans":"loc_4","checked":false},{"id":6,"trans":"loc_6","checked":true}]);
                    break;
                default:
                    $localstorage.setObject('Locs', [{"id":1,"trans":"loc_1","checked":true},{"id":2,"trans":"loc_2","checked":false},{"id":3,"trans":"loc_3","checked":false},{"id":4,"trans":"loc_4","checked":false},{"id":6,"trans":"loc_6","checked":false}]);
                    break;

            }

            // Cache leeren damit die eventuell neue Währung überall angezeigt wird
            $ionicHistory.clearCache();

            $state.go('tab.whd-de');
        }

        // Badges
        $scope.changeBadges = function() {
            if (typeof analytics !== 'undefined') analytics.trackEvent('Funktionen', 'changeBadges', this.badges);
            $localstorage.setObject('Badge', this.badges);
            $scope.badges = this.badges;

            // Cache leeren damit die eventuell neue Währung überall angezeigt wird
            $ionicHistory.clearCache();
        }

        // Thumbs
        $scope.changeThumbs = function() {
            if (typeof analytics !== 'undefined') analytics.trackEvent('Funktionen', 'changeThumbs', this.thumbs);
            $localstorage.setObjectKey('View', 'thumbs', parseInt(this.thumbs));
            $scope.thumbs = this.thumbs;

            // Cache leeren damit die eventuell neue Währung überall angezeigt wird
            $ionicHistory.clearCache();
        }

        // Title
        $scope.changeTitles = function() {
            if (typeof analytics !== 'undefined') analytics.trackEvent('Funktionen', 'changeTitle', this.titles);
            $localstorage.setObjectKey('View', 'titles', this.titles);
            $scope.titles = this.titles;

            // Cache leeren damit die eventuell neue Währung überall angezeigt wird
            $ionicHistory.clearCache();
        }

        // Prices
        $scope.changePrices = function() {
            if (typeof analytics !== 'undefined') analytics.trackEvent('Funktionen', 'changePrices', this.prices);
            $localstorage.setObjectKey('View', 'prices', parseInt(this.prices));
            $scope.prices = this.prices;

            // Cache leeren damit die eventuell neue Währung überall angezeigt wird
            $ionicHistory.clearCache();
        }
    })

    .controller('ImpressumCtrl', function($scope, $mem_scopes) {

        $mem_scopes.store('ImpressumCtrl', $scope);
    });
